<?php
namespace Example;

interface Logger {
    const WARN = 'warning';
    public function log($line);
}

class SimpleLogger {
    protected $level;
    public function __construct($level) {
        $this->level = $level;
    }

    public function log($line) {
        echo $line, PHP_EOL;
    }
}

class App {
    private $logger;
    public function setLogger(Logger $logger) {
        $this->logger = $logger;
    }

    public function run() {
        $this->logger->log('Example');
    }
}

$app = new App;
$app->setLogger(new class(Logger::WARN) extends SimpleLogger implements Logger {
    public function log($line) {
        echo "CustomLogger called({$this->level}): {$line}", PHP_EOL;
    }
});

$app->run();
